/***********************************************************
 * kdisas.c
 *
 * disassembles a part of a file
 *
 * (c) 2003 void.at
 * greuff <greuff@void.at>
 *
 ***********************************************************/

/* includes */
#include <stdio.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <errno.h>
#include <termios.h>
#include <sys/fcntl.h>
#include <asm/ioctls.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <pty.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <string.h>

#include "libdis.h"

#define DEBUG

int main(int argc, char **argv)
{
   int fd;
   unsigned long addr;
   unsigned long len, pos, size;
   struct instr i;
   char *buf;

   printf("fdisas - (c) 2003 by void.at\ngreuff <greuff@void.at>\n\n");
   if(argc!=4)
   {
      help();
      return -1;
   }
   if((fd=open(argv[1],O_RDONLY))<0)
   {
      perror("open");
      return -1;
   }
   addr=strtoul(argv[2],NULL,16);
   len=strtoul(argv[3],NULL,10);

   if((buf=mmap(NULL,len,PROT_READ,MAP_SHARED,fd,addr))==NULL)
   {
      perror("mmap");
      return -1;
   }

   printf("Using offset 0x%08x length %ld\n",addr,len);
   pos=0;
   disassemble_init(0,INTEL_SYNTAX);
   while((pos+32)<len)
   {
      size=disassemble_address(buf+pos,&i);
      if(size)
      {
         printf("instruction (size=%d): %s %s,%s %s\n",size,i.mnemonic,
               i.dest,i.src,i.aux);
         pos+=size;
      }
      else
      {
         printf("unknown op\n");
         pos++;
      }
   }
   disassemble_cleanup();
   munmap(buf,len);
   close(fd);
   return 0;  // to keep compiler happy
}

/***********************************************************************/

int help() {
   printf("Usage: fdisas filename 0xoffset length\n\n");
   return 0;
}

/***********************************************************************/

void readkmem(int kmemfd, unsigned long offset, void *buffer, unsigned int size)
{
   if(lseek(kmemfd,offset,SEEK_SET)!=offset)
   {
      perror("kmem lseek");
      exit(-1);
   }
   if(read(kmemfd,buffer,size)!=size)
   {
      perror("kmem read");
      exit(-1);
   }
}
